//+------------------------------------------------------------------+
//|                              Williams_ROC_Rainbow_Oscillator.mq4 |
//|                                        Copyright  2010, Brooky. |
//|                                         http://www.NoLinkYet.com |
//| Requires Williams_ROC_Rainbow_TF_select.mq4 to run               |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Brooky."
#property link      "http://www.NoLinkYet.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 SteelBlue
#property indicator_color2 Gray
#property indicator_color3 Yellow
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 LimeGreen
#property indicator_color7 Pink

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2

//---- input parameters
extern int       Bars_Back=5000;

extern int       force_period = 7;
extern int       force_mode  = 2;
extern int       force_shift = 0;

extern int       sig_period = 3;
extern int       sig_mode = 2;
extern int       sig_shift = 0;

extern int       Div_Fast_period = 13;
extern double    ShortDivFilter = 0.0001;
extern double    LongDivFilter = 0.0003;
extern int       ShortDivBars = 34;
extern int       LongDivBars = 13;
/*
MODE_SMA 0 Simple moving average, 
MODE_EMA 1 Exponential moving average, 
MODE_SMMA 2 Smoothed moving average, 
MODE_LWMA 3 Linear weighted moving average. 
*/

//---- buffers
double HistUpBuffer[];
double HistDnBuffer[];
double ForceArray[];
double ROC_Line_Buffer[];
double ROCArray[];
double DivLongBuffer[];
double DivShortBuffer[];
double ForceArrayRaw[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   
   SetIndexBuffer(0,HistUpBuffer);SetIndexStyle(0,DRAW_HISTOGRAM);
   
   SetIndexBuffer(1,HistDnBuffer);SetIndexStyle(1,DRAW_HISTOGRAM);
   
   SetIndexBuffer(2,ForceArray);SetIndexStyle(2,DRAW_LINE);
      
   SetIndexBuffer(3,ROC_Line_Buffer);SetIndexStyle(3,DRAW_LINE);
   
   SetIndexBuffer(4,ROCArray);SetIndexStyle(4,DRAW_LINE);
   

   SetIndexBuffer(5,DivLongBuffer);SetIndexStyle(5,DRAW_LINE);

   
   SetIndexBuffer(6,DivShortBuffer);SetIndexStyle(6,DRAW_LINE);

   
   SetIndexBuffer(7,ForceArrayRaw);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {

  //-----Set the averaging Arrays
   ArrayResize(ROCArray, Bars_Back);
   ArraySetAsSeries(ROCArray, true);
   
   ArrayResize(ForceArray, Bars_Back);   
   ArraySetAsSeries(ForceArray, true);
  //---- main loop
    // for(int i=0; i<limit; i++)
     for(int i = Bars_Back-1; i >= 0; i--)
       {
       
       //---- Need different strengths for force on different tfs
       int force_smooth;
       if(Period()==1)force_smooth=10;
       if(Period()==5)force_smooth=90;
       if(Period()==15)force_smooth=200;
       if(Period()==30)force_smooth=260;
       if(Period()==60)force_smooth=800;
       if(Period()==240)force_smooth=2400;
       if(Period()==1440)force_smooth=19200;
       if(Period()==10080)force_smooth=38400;
       if(Period()==43200)force_smooth=96800;
       
       
        //---- ROC iCustom Rainbow HERE

        double ROCup =iCustom(NULL, 0, "Williams_ROC_Rainbow_TF_select",Bars_Back,2,i);
         double ROCup2 =iCustom(NULL, 0, "Williams_ROC_Rainbow_TF_select",Bars_Back,2,i+1);
            double ROCup3 =iCustom(NULL, 0, "Williams_ROC_Rainbow_TF_select",Bars_Back,2,i+2);
            
        double ROCdn =iCustom(NULL, 0, "Williams_ROC_Rainbow_TF_select",Bars_Back,3,i);
         double ROCdn2 =iCustom(NULL, 0, "Williams_ROC_Rainbow_TF_select",Bars_Back,3,i+1);
            double ROCdn3 =iCustom(NULL, 0, "Williams_ROC_Rainbow_TF_select",Bars_Back,3,i+2);
           
            
            
         //---- Force HERE
         double myforce = iForce(NULL, 0, force_period,MODE_SMA,PRICE_CLOSE,i)/(force_smooth); 
        ForceArrayRaw[i] = myforce;
        
        //----Line around ROC Histo 
        ROC_Line_Buffer[i]=(((ROCup+ROCup2+ROCup3)/3)  - ((ROCdn+ROCdn2+ROCdn3)/3));
        
        //----Give the Histo's some ROC values
        if((((ROCup+ROCup2+ROCup3)/3)  - ((ROCdn+ROCdn2+ROCdn3)/3))>=0) HistUpBuffer[i]=(((ROCup+ROCup2+ROCup3)/3)  - ((ROCdn+ROCdn2+ROCdn3)/3));
        if((((ROCup+ROCup2+ROCup3)/3)  - ((ROCdn+ROCdn2+ROCdn3)/3))<=0) HistDnBuffer[i]=(((ROCup+ROCup2+ROCup3)/3)  - ((ROCdn+ROCdn2+ROCdn3)/3));
       }
       //---Fire up the ROC Signal Array
          for(i = Bars_Back-1; i >= 0; i--)
          { 
       //-----Sig Line
           ROCArray[i]=iMAOnArray(ROC_Line_Buffer,0,sig_period,sig_shift,sig_mode,i);
          }
          
       //---Force Array
           for(i = Bars_Back-1; i >= 0; i--)
          { 
          //-----Sig Line
           ForceArray[i]=iMAOnArray(ForceArrayRaw,0,force_period,force_shift,force_mode,i);
          }
     //--------divergence
                     for(i = Bars_Back-1; i >= 0; i--)
          {
          double atrroc =  iATR(NULL,0,Div_Fast_period,i)-iATR(NULL,0,Div_Fast_period,i+2);
          
          double divfast = iMAOnArray(ForceArrayRaw,0,Div_Fast_period,force_shift,force_mode,i);
          double divslow = iMAOnArray(ForceArrayRaw,0,Div_Fast_period+ShortDivBars,force_shift,force_mode,i);
          double divslowlongs = iMAOnArray(ForceArrayRaw,0,Div_Fast_period+LongDivBars,force_shift,force_mode,i);
          
          double diff =divfast-divslow;
          double longdiff =divfast-divslowlongs;
          
          
         if( diff >= ShortDivFilter+atrroc )
        {
         
         DivShortBuffer[i]  = ROC_Line_Buffer[i]+(diff-ShortDivFilter);
        }

      if( longdiff <= ((LongDivFilter+atrroc)*(-1)) )
        {
         
         DivLongBuffer[i]  = ROC_Line_Buffer[i]+(diff-LongDivFilter);
        }
           
        }        
          
          

        
  //---- done
     return(0);
    }
//+------------------------------------------------------------------+